/* ------------------------------------------------------------------------------------
 * Utilisateur rel et effectif et "set user's bit"
 * Jean-Paul Rigault 
 *
 * Cet excutable peut tre test avec le fichier d'essai exo5-test.txt pour
 * lequel la Makefile installe des droits restreints (et adquats) 
 * ------------------------------------------------------------------------------------
 */
#include <unistd.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include <fcntl.h> 

/* Indiquer ici l'UID de l'utilisateur qui a le privilge de lire vos fichiers */
const uid_t PRIV_UID =  500; /* 25502; */ 

/* Taille du buffer de lecture */
#define MAX_BUFF 1024

int main(int argc, char *argv[])
{
    int ruid;
    int fd;
    int n;
    char buff[MAX_BUFF];

    /* Il est assez dlicat dans le cas gnral --- c'est--dire sans savoir a
     * priori ou est le fichier binaire excutable --- mais pas impossible (
     * faire  titre d'exercice) de vrifier que le programme a bien t
     * install avec le "set user bit" ; on se contente donc ici de ce message
     */
    fprintf(stderr, "Attention : vrifiez que ce programme %s est install\n"
            "avec le \"set user's bit\" "
	    "sinon cela ne marchera pas !\n\n", argv[0]);

    /* Il est encore plus dlicat de vrifier si ce programme rside sur un
     * volume o l'on peut utiliser le set user bit
     */
    fprintf(stderr, "Attention : le programme %s doit tre install sur un systme\n"
            "de fichiers o le \"set user's bit\" est accept\n"
            "(voir options de mount) sinon cela ne marchera pas !\n\n", argv[0]);

    /* On vrifie que l'UID *rel* du processus est celui de l'utilisateur
     * privilgi
     */
    ruid = getuid();
    if (ruid != PRIV_UID)
    {
	fprintf(stderr, "Erreur : vous n'tes pas autoris  utiliser ce programmme\n");
        fprintf(stderr, "votre uid est %d, celui autoris est %d\n", ruid, PRIV_UID);
	exit(1);
    }

    /* On envoie un message disant que le changement d'identit est possible ;
     * ici  cause du set user bit, luid effectif doit tre celui du
     * propritaire de cet excutable (celui qui accorde l'accs) */

    fprintf(stderr, "L'UID %d peut accder aux fichiers lisibles par l'UID %d\n\n",
	    ruid, geteuid()); 

    /* On lit le nom du fichier  consulter depuis les paramtres de la ligne
     * de commande
     */
    if (argc != 2) 
    {
	fprintf(stderr, "Usage: %s fichier\n", argv[0]);
	exit(1);
    }

    /* On ouvre le fichier et on imprime le contenu ; quand l'utilisateur
     * effectif est le propritaire du fichier  lire, et qu'il a luii-mme le
     * droit de lire, ceci doit marcher
     */
    if ((fd = open(argv[1], O_RDONLY)) < 0)
    {
	perror("open");
	exit(1);
    }

    printf("============== Dbut de fichier ====================\n");
    while ((n = read(fd, buff, MAX_BUFF)) > 0) write(1, buff, n);
    printf("============== Fin de fichier ====================\n");

    /* Fin du programme */
    exit(0);
}


