/* ------------------------------------------------------------------------------------
 * Cration de 10 processus s'excutant en parallle 
 * Jean-Paul Rigault 
 * ------------------------------------------------------------------------------------
 */
#include <unistd.h> 
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>

#define NPROCESS 10
#define NLOOP 10

int main()
{
  int i;
  int j;
  
  /* Cration de 10 processus s'excutant en parallle */
  
  for (i = 0; i < NPROCESS; ++i)
    {
      switch (fork())
	{ 
	case -1:
	  perror("fork");
	  abort();
	  
	case 0:
	  /* Processus fils de numro i */
	  
	  /* Chaque fils affiche 10 fois son numro (i)  */
	  for (j=0; j < NLOOP; ++j)
            {
	      printf("%1d\n", i);
	      /* Avec la ligne suivante, les excutions s'entrelacent */
	      /* sleep(1); */
            }
	  
	  /* Fin du fils : ATTENTION  ne pas l'oublier, sinon cration d'un
	   * grand nombre (exponentiel) de processus */
	  exit(0);
	  
	default:
	  /* Suite du processus pre */
	  
	  /* On reboucle pour crer les fils suivants */
	  break;	   
	}
    }
  
  /* Mesure de salubrit sociale, le pre attend la fin de tous ses fils */
  for (i = 0; i < NPROCESS; ++i) wait(0);
  
  /* On flushe la sortie standard */
  fflush(stdout);
  
  /* Ce message va sur l'erreur standard pour viter de polluer la sortie */
  fprintf(stderr, "Vrifier le nombre de caractres (en principe 200)"
	  " en \"pipant\" avec \'wc -c\'\n");
  
  /* Fin du pre */
  exit(0);
}


