/* ------------------------------------------------------------------------------------
 * Simulation de la boucle principale du shell
 * Cette version utilise une version (incomplte) de system()
 * Jean-Paul Rigault 
 * ------------------------------------------------------------------------------------
 */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <limits.h>

/* Dclaration en avant */
int my_system(const char *);

/* Excution directe des commandes built-in */
int exec_builtin(char *line);

/* Affichage du prompt */
void prompt();

/* Buffer pour la ligne de commande */
#define LINE_MAX 2048
char line[LINE_MAX];

int main()
{
    /* Boucle du shell */
    prompt();
    while (fgets(line, LINE_MAX, stdin))
    {
        line[strlen(line) - 1] = '\0'; /* enlve le \n */
        if (!exec_builtin(line)) my_system(line);
        prompt();
    }

    /* Fin du programme */
    exit(0);
}

/* La fonction system() elle-mme
 *
 * ATTENTION : il s'agit d'une version *rustique* qui ne gre pas correctement
 * les signaux (voir le chapitre consacr aux signaux dans le cours)
 */
int my_system(const char *cmd)
{
    char *shell;
    int status;

    /* Rcupre le shell de l'utilisateur : le shell par dfaut est "sh" */   
    shell = getenv("SHELL");
    if (shell == 0 || strcmp(shell, "") == 0)
	shell = "sh";

    /* Excution de la commande */
    switch (fork())
    {
    case -1:
	perror("fork");
	abort();

    case 0: /* Processus fils qui excute la commande */
	execlp(shell, shell, "-c", cmd, 0);
	/* On ne doit pas passer ici */
	perror("exit ls");
	exit(1); /* Surtout pas return ! */

    default: /* Le pre attend et rcupre le code de retour */
	wait(&status); 
	break;	   
    }

    /* On retourne le code renvoy par le shell */
    return status;
}

/* Excution directe des commandes built-in */

int exec_builtin(char *line)
{
    char *cmd;

    /* Recherche du nom de la commande */
    cmd = strtok(line, " ");
    
    /* ici, on n'a une seule commande built-in, cd */
    if (strcmp(cmd, "cd") == 0)
    {
        char *dir = strtok(NULL, " ");
        if (chdir(dir) < 0) perror("chdir");
        if (strtok(NULL, " ") != NULL)
            fprintf(stderr, "Commande cd : trop d'arguments (ignors)\n");  

        return 1;
    }    

    /* Ici, ce n'tait pas une commande builtin */
    return 0;
}

/* Affichage du prompt */
void prompt()
{
    printf("$ ");
    fflush(stdout);
}

